-----------------------------------------------------------------
--   File: spROM.sv
--   creates a synchronous single-port rom.
--   Initialization file passed as generic
-----------------------------------------------------------------*/

library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_Std.all;

library std ;
use std.textio.all;



entity spROM is
  generic (initFile : string := "dummy_file_name.mif");
  port (
   CLK        : in  std_logic;          
   ADDRESS    : in  std_logic_vector;
   DATAOUT    : out std_logic_vector
);
end entity spROM;


architecture arcspROM of spROM is

  type romType is array(0 to 2**ADDRESS'length-1) of std_logic_vector(DATAOUT'length-1 downto 0);
   
  -- uses VHDL 2008 hread
	impure function initRomFromFile return romType is
    file data_file : text open read_mode is initFile;
		variable data_fileLine : line;
		variable ROM           : romType;
  begin
    for I in romType'range loop
		  readline(data_file, data_fileLine);
			hread(data_fileLine, ROM(I));
		 end loop;
	   return ROM;
	end function;
   
 signal rom : romType := initRomFromFile; 
 
 attribute rom_style : string;
 attribute rom_style of rom : signal is "block";
 
    
begin

  process (CLK)
  begin
    if (CLK'event and CLK = '1') then
      DATAOUT <= rom(to_integer(unsigned(ADDRESS)));
    end if;
  end process;
  

end architecture arcspROM;
-----------------------------------------------------------------
--   End of File: spROM.vhd
-----------------------------------------------------------------


